#define MAX_EFFECTS		32
#define MAX_PROJECTILES	32
#define MAX_ENTITIES	512
#define MAX_CHARACTERS	128
#define MAX_SECTORS		100

// Entity defines
#define ENT_COIN		0
#define ENT_FIREBOW		1
#define ENT_ICEBOW		2
#define ENT_DARKBOW		3
#define ENT_GOALFLAG	4

// Projectile defines
#define PROJ_FIREBALL	0


// Effect defines
#define FX_BPARTICLE	0
#define FX_DPARTICLE	1
#define FX_SPRITEBIT	2


// Character defines
#define CHAR_NATALIE	0
#define CHAR_MONOHEAD	1
#define CHAR_HOPPYHEAD	2
#define CHAR_FLYHEAD	3


// HP defines of characters
#define CHAR_NATALIE_HP		1
#define CHAR_MONOHEAD_HP	1
#define CHAR_HOPPYHEAD_HP	1
#define CHAR_FLYHEAD_HP		1


// Logic defs
#define	RESULT_QUIT				0
#define RESULT_RESTART			1
#define RESULT_WINLEVEL			2
#define RESULT_GAMEOVER			3


#define GRAVITY			600			// Gravity
#define FALL_LIMIT		10			// Fall speed limit (in pixels speed units)


char CharWidthTable[] =	{
	3, // SPACE
	
	3, 5, 7, 7, 7, 7, 4, 4, 4, 7,	// ~ " # $ % & ' ( ) *
	7, 4, 6, 3, 7, 6, 5, 6, 6, 6,	// + , - . / 0 1 2 3 4
	6, 6, 6, 6, 6, 3, 4, 5, 5, 5,	// 5 6 7 8 9 : ; < = >
	7, 7, 6, 7, 6, 7, 7, 7, 6, 6,	// ? @ A B C D E F G H
	5, 7, 6, 6, 7, 6, 6, 7, 7, 6,	// I J K L M N O P Q R
	6, 7, 6, 7, 7, 6, 6, 7, 4, 7,	// S T U V W X Y Z [ \*
	4, 5, 6, 4, 7, 6, 6, 6, 6, 5,	// ] ^ _ ` a b c d e f
	7, 6, 3, 5, 6, 4, 7, 6, 6, 6,	// g h i j k l m n o p
	6, 6, 5, 5, 7, 7, 7, 5, 5, 5,	// q r s t u v w x y z	
	
	7,	// Cross
	7,	// Circle
	7,	// Square
	7,	// Triangle
	8,	// Start
	8,	// Select (128)
	
	6,	// Up
	6,	// Down
	6,	// Left
	6,	// Right
	
	7,	// L1
	8,	// R1
	8,	// L2
	9	// R2
	
};

char CharWidthTableSmall[] =	{
	3, // SPACE
	0, 0, 0, 0, 0, 0, 0, 3, 3, 4,	// ~ " # $ % & ' ( ) *
	4, 3, 4, 2, 4, 4, 2, 4, 4, 4,	// + , - . / 0 1 2 3 4
	4, 4, 4, 4, 4, 2, 3, 4, 4, 4,	// 5 6 7 8 9 : ; < = >
	4, 4, 4, 4, 4, 4, 4, 4, 4, 4,	// ? @ A B C D E F G H
	4, 4, 4, 4, 4, 4, 4, 4, 4, 4,	// I J K L M N O P Q R
	4, 4, 4, 4, 4, 4, 4, 4			// S T U V W X Y Z
};

#define CENTERED	0x7fff


struct {
	int		x,y;
	short	dir;
} StartPos;

int			ScreenAdjustMode=0;
int			PlayLevelNum=0;

int			NumPlayers=1;
PLAYERSTUFF	Player[2]={0};
PLAYERINPUT	PlayerInput[2]={0};
STATSTRUCT	PlayerStats={0};

int			NumCharacters=0;
CHARSTRUCT	*CharacterList_ptr=0;

int			NumEffects=0;
FXSTRUCT	*EffectsList_ptr=0;

int			NumProjectiles=0;
PROJSTRUCT	*ProjectileList_ptr=0;

int			NumEntities=0;
ENTSTRUCT	*EntityList_ptr=0;


// For the dialog system
short	DialogState=0;
short	DialogLine=0;
short	DialogFull=0;
short	DialogTyping=0;
short	DialogCount=0;
short	DialogMode=0;

char	*ScriptCharBase_ptr;
char	*ScriptChar_ptr;
char	*DialogBuff_ptr[4];

PLAYERINPUT	BlankPlayerInput = {0};


// Function prototypes
int		main();

int		DoMainMenu();
void	DoOptionsStuff(short *MenuSel, PLAYERINPUT *istuff);
void	DoLogoStuff();

void	DoPlayerLogic(PLAYERSTUFF *pstuff, PLAYERINPUT *istuff);
void	DoFairyLogic(PLAYERSTUFF *pstuff, PLAYERINPUT *istuff);

void	DoPlayerCollision(PLAYERSTUFF *pstuff);
void	GiveCoins(PLAYERSTUFF *pstuff, int coins);
void	HurtPlayer(PLAYERSTUFF *pstuff, int xMove, int damage);

// Dialog system functions
int		GetScriptEntry(char *SearchTag, char *Output);
char	*GetScriptEntryPos(char *SearchTag);
char	*NextLine(char *CharPos_ptr);
void	StartDialog(int DialogNum);
void	FlushDialog();
void	ScrollDialogUp();
void	DoDialog(int next);

void	DrawPlayerSpriteLogic(PLAYERSTUFF *pstuff);
void	DrawFairySpriteLogic(PLAYERSTUFF *pstuff);

void	ProjectileLogic(PROJSTRUCT *ProjectileEntry, SPRITE *Sprite, int *Delete);
void	CharacterLogic(CHARSTRUCT *CharacterEntry, SPRITE *Sprite, int px, int py, int *Delete, int *Visible);

int		CharacterHit(int x, int y, int xMove, int yMove, int Damage);
void	DestroyTile(short tx, short ty, int frombelow);