GsSPRITE PrepSprite (GsIMAGE TimImage);
GsIMAGE LoadTIM (u_long *tMemAddress);
GsSPRITE CalcSpriteCoords(GsIMAGE TimParams, int u, int v, int w, int h, int mx, int my);


GsSPRITE PrepSprite (GsIMAGE TimImage) {

	// Returns a GsSPRITE structure so that TimImage can be displayed using GsSortSprite.

	GsSPRITE tSprite;
		
	// Set texture size and coordinates
	switch (TimImage.pmode & 3) {
		case 0: // 4-bit
			tSprite.w = TimImage.pw << 2;
			tSprite.u = (TimImage.px & 0x3f) * 4;
			break;
		case 1: // 8-bit
			tSprite.w = TimImage.pw << 1;
			tSprite.u = (TimImage.px & 0x3f) * 2;
			break;
		default: // 16-bit
			tSprite.w = TimImage.pw;
			tSprite.u = TimImage.px & 0x3f; 
    };
	
	tSprite.h = TimImage.ph;
	tSprite.v = TimImage.py & 0xff;

	// Set texture page and attributes
	tSprite.tpage 		= GetTPage((TimImage.pmode & 3), 0, TimImage.px, TimImage.py);
	tSprite.attribute 	= (TimImage.pmode & 3) << 24;
	
	// CLUT coords
	tSprite.cx 			= TimImage.cx;
	tSprite.cy 			= TimImage.cy;
	
	// Default position, color intensity, and scale/rotation values
	tSprite.x = tSprite.y 				= 0;
	tSprite.mx = tSprite.my				= 0;
	tSprite.r = tSprite.g = tSprite.b 	= 128;
	tSprite.scalex = tSprite.scaley 	= ONE;
	tSprite.rotate 						= 0;
	
	return tSprite;

}


GsIMAGE LoadTIM (u_long *tMemAddress) {

	RECT tRect;
	GsIMAGE tTim;

	tMemAddress++;
	GsGetTimInfo(tMemAddress, &tTim);	// Get TIM info from TIM

	tRect.x = tTim.px;
	tRect.y = tTim.py;
	tRect.w = tTim.pw;
	tRect.h = tTim.ph;
	LoadImage(&tRect, tTim.pixel);		// Load TIM data into framebuffer
	DrawSync(0);

	if ((tTim.pmode >> 3) & 0x01) {
		tRect.x = tTim.cx;
		tRect.y = tTim.cy;
		tRect.w = tTim.cw;
		tRect.h = tTim.ch;
		LoadImage(&tRect, tTim.clut);	// Load CLUT into framebuffer
		DrawSync(0);
	}
	
	return tTim;
	
}


GsSPRITE CalcSpriteCoords(GsIMAGE TimParams, int u, int v, int w, int h, int mx, int my) {

	GsSPRITE tSprite;
	
	// Set texture X coordinate
	switch (TimParams.pmode & 3) {
		case 0: // 4-bit
			tSprite.u = ((TimParams.px & 0x3f) * 4) + (u % 256);
			break;
		case 1: // 8-bit
			tSprite.u		= ((TimParams.px & 0x3f) * 2) + (u % 256);
			
			tSprite.tpage	= GetTPage(TimParams.pmode & 3, 0, TimParams.px + (128 * (u / 256)), TimParams.py + (256 * (v / 256)));
			
			break;
		default: // 16-bit
			tSprite.u = (TimParams.px & 0x3f) + (u % 256);
    };
	
	// Set texture Y coordinate
	tSprite.v = (TimParams.py & 0xff) + (v % 256);
	
	// Set size of sprite
	tSprite.w = w;
	tSprite.h = h;
	
	// Set color mode of sprite
	tSprite.attribute	= (TimParams.pmode & 3) << 24;
	
	// CLUT coords
	tSprite.cx 			= TimParams.cx;
	tSprite.cy 			= TimParams.cy;
	
	// Set default position, color intensity, and scale/rotation values of sprite
	tSprite.x=tSprite.y				= 0;
	tSprite.mx=tSprite.my			= 0;
	tSprite.r=tSprite.g=tSprite.b	= 128;
	tSprite.scalex=tSprite.scaley	= ONE;
	tSprite.rotate					= 0;
	
	return tSprite;
	
}